diff --git a/libvips/foreign/exif.c b/libvips/foreign/exif.c
index 12b2d4484..319507ac5 100644
--- a/libvips/foreign/exif.c
+++ b/libvips/foreign/exif.c
@@ -525,7 +525,8 @@ vips__exif_parse( VipsImage *image )
 		int orientation;
 
 		orientation = atoi( str );
-		orientation = VIPS_CLIP( 1, orientation, 8 );
+		if( orientation < 1 || orientation > 8 )
+			orientation = 1;
 		vips_image_set_int( image, VIPS_META_ORIENTATION, orientation );
 	}
 
diff --git a/test/test-suite/test_foreign.py b/test/test-suite/test_foreign.py
index 3d9b6b90b..4c18af711 100644
--- a/test/test-suite/test_foreign.py
+++ b/test/test-suite/test_foreign.py
@@ -189,6 +189,18 @@ def jpeg_valid(im):
             assert x1.width == x2.height
             assert x1.height == x2.width
 
+            # sets incorrect orientation, save, load again, orientation
+            # has reset to 1
+            x = x.copy()
+            x.set("orientation", 256)
+
+            filename = temp_filename(self.tempdir, '.jpg')
+            x.write_to_file(filename)
+
+            x = pyvips.Image.new_from_file(filename)
+            y = x.get("orientation")
+            assert y == 1
+
             # can set, save and reload ASCII string fields
             x = pyvips.Image.new_from_file(JPEG_FILE)
             x = x.copy()
